﻿#!/usr/bin/perl -w
#  perl myscript.pl infile
# fasta 形式をのファイルとハッシュに組み込みます．

use strict;
use warnings;

my $filename = "$ARGV[0]";
my $outfile = "Out_".$filename;

my $name = '';
my $seq = '';

my $milestone = 0;

my @contents = ( );
my @spOrder = ( );
my %efas = ( );
my %efas_rev = ( );

open (FFILE,"$filename");
@contents = <FFILE>;
close FFILE;


########## @spOrder の作成
open(SPORDER,"SppOrder");
@spOrder = <SPORDER>;
close SPORDER;

#print "@spOrder";


########## %efas の作成
# fastafile から OTU 名と seq 行をハッシュ %efas に格納する
foreach my $line (@contents) {
if ($line =~ /^>/) {
  if ($milestone == 0) { 
        chomp($line);
        $name = $line;
        $milestone = 1;
     } else {
#       print "$name\n$seq\n";
        $efas{$name} = $seq;
        $seq = "";
        chomp($line);
        $name = $line;        
     }
  } else {
      chomp($line);
      $seq .= $line;
  }
}

#print "$name\n$seq\n";
$efas{$name} = $seq;


###########  %efas のプリントアウト
open(OUT,">$outfile");
#foreach my $pname (keys %efas) {
foreach my $pname (@spOrder) {
   chomp($pname);
#   print "sporder:$pname\n";
   if(grep/$pname/,keys %efas) {
     print OUT "$pname\n$efas{$pname}\n";
   }
}
print OUT "\n";
close OUT;
  

exit;
